/* zconf.h -- configuration of the zlib compression library
 * Copyright (C) 1995-2005 Jean-loup Gailly.
 * For conditions of distribution and use, see copyright notice in zlib.h
 */


/* $Id: zconf.h,v 1.17 2006/08/07 18:55:17 tm Exp $ */
/* @(#) $Id: zconf.h,v 1.17 2006/08/07 18:55:17 tm Exp $ */

#ifndef ZCONF_H
#define ZCONF_H

#include "pc_config.h"

/*
 * If you *really* need a unique prefix for all types and library functions,
 * compile with -DZ_PREFIX. The "standard" zlib should be compiled without it.
 */
/* PDFlib GmbH: We use "pdf_z_".
** The original list was incomplete, by the way.
*/
#define Z_PREFIX
#ifdef	Z_PREFIX

/* redefine names of all functions for integrating into
   * psp library, to avoid name clashes if used together with
   * pdflib */
#ifdef PDFLIB_TET_BUILD
#define FLATE_PREFIX(x)	tet_z_##x
#else
#ifdef PDFLIB_PLOP_BUILD
#define FLATE_PREFIX(x)	plop_z_##x
#else
#ifdef PDFLIB_PCOS_BUILD
#define FLATE_PREFIX(x)	pcos_z_##x
#else
#define FLATE_PREFIX(x)	pdf_z_##x
#endif /* PDFLIB_PCOS_BUILD */
#endif /* PDFLIB_PLOP_BUILD */
#endif /* PDFLIB_TET_BUILD */

#  define inflate_copyright     FLATE_PREFIX(inflate_copyright)
#  define inflate_table         FLATE_PREFIX(inflate_table)
#  define _dist_code          FLATE_PREFIX(_dist_code)
#  define _length_code          FLATE_PREFIX(_length_code)
#  define _tr_align          FLATE_PREFIX(_tr_align)
#  define _tr_flush_block          FLATE_PREFIX(_tr_flush_block)
#  define _tr_init          FLATE_PREFIX(_tr_init)
#  define _tr_stored_block          FLATE_PREFIX(_tr_stored_block)
#  define _tr_tally          FLATE_PREFIX(_tr_tally)
#  define zcalloc          FLATE_PREFIX(zcalloc)
#  define zcfree          FLATE_PREFIX(zcfree)
#  define z_errmsg          FLATE_PREFIX(z_errmsg)
#  define z_error          FLATE_PREFIX(z_error)
#  define zlibCompileFlags          FLATE_PREFIX(zlibCompileFlags)
#  define zlibVersion          FLATE_PREFIX(zlibVersion)
#  define z_verbose          FLATE_PREFIX(z_verbose)
#  define inflateGetHeader          FLATE_PREFIX(inflateGetHeader)
#  define inflatePrime          FLATE_PREFIX(inflatePrime)
#  define adler32_combine          FLATE_PREFIX(adler32_combine)
#  define inflate_fast          FLATE_PREFIX(inflate_fast)
#  define crc32_combine          FLATE_PREFIX(crc32_combine)
#  define deflate_copyright          FLATE_PREFIX(deflate_copyright)
#  define deflateSetHeader          FLATE_PREFIX(deflateSetHeader)
#  define deflateTune          FLATE_PREFIX(deflateTune)

#  define deflateInit_          FLATE_PREFIX(deflateInit_)
#  define deflate               FLATE_PREFIX(deflate)
#  define deflateEnd            FLATE_PREFIX(deflateEnd)
#  define inflateInit_          FLATE_PREFIX(inflateInit_)
#  define inflate               FLATE_PREFIX(inflate)
#  define inflateEnd            FLATE_PREFIX(inflateEnd)
#  define deflateInit2_         FLATE_PREFIX(deflateInit2_)
#  define deflateSetDictionary  FLATE_PREFIX(deflateSetDictionary)
#  define deflateCopy           FLATE_PREFIX(deflateCopy)
#  define deflateReset          FLATE_PREFIX(deflateReset)
#  define deflateParams         FLATE_PREFIX(deflateParams)
#  define deflateBound          FLATE_PREFIX(deflateBound)
#  define deflatePrime          FLATE_PREFIX(deflatePrime)
#  define inflateInit2_         FLATE_PREFIX(inflateInit2_)
#  define inflateSetDictionary  FLATE_PREFIX(inflateSetDictionary)
#  define inflateSync           FLATE_PREFIX(inflateSync)
#  define inflateSyncPoint      FLATE_PREFIX(inflateSyncPoint)
#  define inflateCopy           FLATE_PREFIX(inflateCopy)
#  define inflateReset          FLATE_PREFIX(inflateReset)
#  define inflateBack           FLATE_PREFIX(inflateBack)
#  define inflateBackEnd        FLATE_PREFIX(inflateBackEnd)
#  define compress              FLATE_PREFIX(compress)
#  define compress2             FLATE_PREFIX(compress2)
#  define compressBound         FLATE_PREFIX(compressBound)
#  define uncompress            FLATE_PREFIX(uncompress)
#  define adler32               FLATE_PREFIX(adler32)
#  define crc32                 FLATE_PREFIX(crc32)
#  define get_crc_table         FLATE_PREFIX(get_crc_table)
#  define zError                FLATE_PREFIX(zError)

#if 0
/*
 * PDFlib GmbH: Avoid these redefinitions since they are not required
 * for typedefs, and can break functions of the same name in other
 * modules.
 */
#  define alloc_func            FLATE_PREFIX(alloc_func)
#  define free_func             FLATE_PREFIX(free_func)
#  define in_func               FLATE_PREFIX(in_func)
#  define out_func              FLATE_PREFIX(out_func)
#endif


/* special handling required on the Mac where Byte is alread defined */
#if !(defined(MAC) || defined(MACOSX))
#  define Byte		z_Byte
#endif

#  define uInt		z_uInt
#  define uLong		z_uLong
#  define Bytef		z_Bytef
#  define charf		z_charf
#  define intf		z_intf
#  define uIntf		z_uIntf
#  define uLongf	z_uLongf
#  define voidpf	z_voidpf
#  define voidp		z_voidp
#endif

#if (defined(_WIN32) || defined(__WIN32__)) && !defined(WIN32)
#  define WIN32
#endif
#if defined(__GNUC__) || defined(WIN32) || defined(__386__) || defined(i386)
#  ifndef __32BIT__
#    define __32BIT__
#  endif
#endif

#if defined(__MSDOS__) && !defined(MSDOS)
#  define MSDOS
#endif
#if (defined(OS_2) || defined(__OS2__)) && !defined(OS2)
#  define OS2
#endif
#if defined(_WINDOWS) && !defined(WINDOWS)
#  define WINDOWS
#endif
#if defined(_WIN32) || defined(_WIN32_WCE) || defined(__WIN32__)
#  ifndef WIN32
#    define WIN32
#  endif
#endif
#if (defined(MSDOS) || defined(OS2) || defined(WINDOWS)) && !defined(WIN32)
#  if !defined(__GNUC__) && !defined(__FLAT__) && !defined(__386__)
#    ifndef SYS16BIT
#      define SYS16BIT
#    endif
#  endif
#endif

/* PDFlib GmbH: Windows CE portability */
#ifdef _WIN32_WCE 
#define NO_ERRNO_H
#endif

/*
 * Compile with -DMAXSEG_64K if the alloc function cannot allocate more
 * than 64k bytes at a time (needed on systems with 16-bit int).
 */
#ifdef SYS16BIT
#  define MAXSEG_64K
#endif
#ifdef MSDOS
#  define UNALIGNED_OK
#endif

#ifndef STDC	/* PDFlib GmbH: we require ANSI C anyway */
#define STDC
#endif

/* Some Mac compilers merge all .h files incorrectly: */
#if defined(__MWERKS__)||defined(applec)||defined(THINK_C)||defined(__SC__)
#  define NO_DUMMY_DECL
#endif

/* Maximum value for memLevel in deflateInit2 */
#ifndef MAX_MEM_LEVEL
#  ifdef MAXSEG_64K
#    define MAX_MEM_LEVEL 8
#  else
#    define MAX_MEM_LEVEL 9
#  endif
#endif

/* Maximum value for windowBits in deflateInit2 and inflateInit2.
 * WARNING: reducing MAX_WBITS makes minigzip unable to extract .gz files
 * created by gzip. (Files created by minigzip can still be extracted by
 * gzip.)
 */
#ifndef MAX_WBITS
#  define MAX_WBITS   15 /* 32K LZ77 window */
#endif

/* The memory requirements for deflate are (in bytes):
            (1 << (windowBits+2)) +  (1 << (memLevel+9))
 that is: 128K for windowBits=15  +  128K for memLevel = 8  (default values)
 plus a few kilobytes for small objects. For example, if you want to reduce
 the default memory requirements from 256K to 128K, compile with
     make CFLAGS="-O -DMAX_WBITS=14 -DMAX_MEM_LEVEL=7"
 Of course this will generally degrade compression (there's no free lunch).

   The memory requirements for inflate are (in bytes) 1 << windowBits
 that is, 32K for windowBits=15 (default value) plus a few kilobytes
 for small objects.
*/

                        /* Type declarations */

#ifndef OF /* function prototypes */
#  ifdef STDC
#    define OF(args)  args
#  else
#    define OF(args)  ()
#  endif
#endif

/* The following definitions for FAR are needed only for MSDOS mixed
 * model programming (small or medium model with some far allocations).
 * This was tested only with MSC; for other MSDOS compilers you may have
 * to define NO_MEMCPY in zutil.h.  If you don't need the mixed model,
 * just define FAR to be empty.
 */
#ifdef SYS16BIT
#  if defined(M_I86SM) || defined(M_I86MM)
     /* MSC small or medium model */
#    define SMALL_MEDIUM
#    ifdef _MSC_VER
#      define FAR _far
#    else
#      define FAR far
#    endif
#  endif
#  if (defined(__SMALL__) || defined(__MEDIUM__))
     /* Turbo C small or medium model */
#    define SMALL_MEDIUM
#    ifdef __BORLANDC__
#      define FAR _far
#    else
#      define FAR far
#    endif
#  endif
#endif

#if defined(WINDOWS) || defined(WIN32)
   /* If building or using zlib as a DLL, define ZLIB_DLL.
    * This is not mandatory, but it offers a little performance increase.
    */
#  ifdef ZLIB_DLL
#    if defined(WIN32) && (!defined(__BORLANDC__) || (__BORLANDC__ >= 0x500))
#      ifdef ZLIB_INTERNAL
#        define ZEXTERN extern __declspec(dllexport)
#      else
#        define ZEXTERN extern __declspec(dllimport)
#      endif
#    endif
#  endif  /* ZLIB_DLL */
   /* If building or using zlib with the WINAPI/WINAPIV calling convention,
    * define ZLIB_WINAPI.
    * Caution: the standard ZLIB1.DLL is NOT compiled using ZLIB_WINAPI.
    */
#  ifdef ZLIB_WINAPI
#    ifdef FAR
#      undef FAR
#    endif
#    include <windows.h>
     /* No need for _export, use ZLIB.DEF instead. */
     /* For complete Windows compatibility, use WINAPI, not __stdcall. */
#    define ZEXPORT WINAPI
#    ifdef WIN32
#      define ZEXPORTVA WINAPIV
#    else
#      define ZEXPORTVA FAR CDECL
#    endif
#  endif
#endif

#if defined (__BEOS__)
#  ifdef ZLIB_DLL
#    ifdef ZLIB_INTERNAL
#      define ZEXPORT   __declspec(dllexport)
#      define ZEXPORTVA __declspec(dllexport)
#    else
#      define ZEXPORT   __declspec(dllimport)
#      define ZEXPORTVA __declspec(dllimport)
#    endif
#  endif
#endif

#ifndef ZEXTERN
#  define ZEXTERN extern
#endif
#ifndef ZEXPORT
#  define ZEXPORT
#endif
#ifndef ZEXPORTVA
#  define ZEXPORTVA
#endif

#ifndef FAR
#  define FAR
#endif

/* PDFlib GmbH: also do the typedef on the Mac
#if defined(MAC) || defined(MACOSX)
#include <MacTypes.h>
#else
*/
#if !defined(__MACTYPES__)
typedef unsigned char  Byte;  /* 8 bits */
#endif

typedef unsigned int   uInt;  /* 16 bits or more */
typedef unsigned long  uLong; /* 32 bits or more */

#ifdef SMALL_MEDIUM
   /* Borland C/C++ and some old MSC versions ignore FAR inside typedef */
#  define Bytef Byte FAR
#else
   typedef Byte  FAR Bytef;
#endif
typedef char  FAR charf;
typedef int   FAR intf;
typedef uInt  FAR uIntf;
typedef uLong FAR uLongf;

#ifdef STDC
   typedef void const *voidpc;
   typedef void FAR   *voidpf;
   typedef void       *voidp;
#else
   typedef Byte const *voidpc;
   typedef Byte FAR   *voidpf;
   typedef Byte       *voidp;
#endif

/* PDFlib GmbH: Windows portability */
#if !defined(WIN32) && !defined(OS2) && !defined(MAC)
#  include <sys/types.h> /* for off_t */
#  include <unistd.h>    /* for SEEK_* and off_t */
#  ifdef VMS
#    include <unixio.h>   /* for off_t */
#  endif
#  define z_off_t off_t
#endif

#ifndef SEEK_SET
#  define SEEK_SET        0       /* Seek from beginning of file.  */
#  define SEEK_CUR        1       /* Seek from current position.  */
#  define SEEK_END        2       /* Set file pointer to EOF plus "offset" */
#endif
#ifndef z_off_t
#  define z_off_t long
#endif

#if defined(__OS400__)
#  define NO_vsnprintf
#endif

#if defined(__MVS__)
#  define NO_vsnprintf
#  ifdef FAR
#    undef FAR
#  endif
#endif

/* MVS linker does not support external names larger than 8 bytes */
#if defined(__MVS__)
#   pragma map(deflateInit_,"DEIN")
#   pragma map(deflateInit2_,"DEIN2")
#   pragma map(deflateEnd,"DEEND")
#   pragma map(deflateBound,"DEBND")
#   pragma map(inflateInit_,"ININ")
#   pragma map(inflateInit2_,"ININ2")
#   pragma map(inflateEnd,"INEND")
#   pragma map(inflateSync,"INSY")
#   pragma map(inflateSetDictionary,"INSEDI")
#   pragma map(compressBound,"CMBND")
#   pragma map(inflate_table,"INTABL")
#   pragma map(inflate_fast,"INFA")
#   pragma map(inflate_copyright,"INCOPY")
#endif

#endif /* ZCONF_H */
